#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "Fish_SquamaDragonArrowCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<Fish_SquamaDragonArrowCFG> Fish_SquamaDragonArrowCFG::msSingleton(nullptr);

int Fish_SquamaDragonArrowCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_SquamaDragonArrowCFGData* Fish_SquamaDragonArrowCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, Fish_SquamaDragonArrowCFGData>& Fish_SquamaDragonArrowCFG::GetMapData()
{
	return mMapData;
}

void Fish_SquamaDragonArrowCFG::Reload()
{
	mMapData.clear();
	Load();
}

void Fish_SquamaDragonArrowCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_SquamaDragonArrowCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mConsume = element->IntAttribute("Consume");
		{
			const char* RewardList = element->Attribute("RewardList");
			std::vector<std::string> vecRewardList;
			boost::split(vecRewardList, RewardList, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecRewardList.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecRewardList[i].c_str(), &temp))
				{
					data.mRewardList.push_back(temp);
				}
			}
		}
		data.mIntegralAddition = element->IntAttribute("IntegralAddition");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void Fish_SquamaDragonArrowCFG::Load()
{
	Load("../Config/Fish_SquamaDragonArrowCFG.xml");
}

Fish_SquamaDragonArrowCFG* Fish_SquamaDragonArrowCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_SquamaDragonArrowCFG());
	}
	return msSingleton.get();
}
